# Video-Livestream

Hier wird beschrieben, mit welcher Ausstattung (Hard- und Software) der Gottesdienst in unserer Gemeinde live übertragen wird. Die Übertragung erfolgt bei uns nicht öffentlich, sondern ist für Gemeindemitglieder und Freunde gedacht, die aus verschiedenen Gründen den Gottesdienst nicht besuche können, aber mit unserer Gemeinde verbunden sind. Voraussetzung dafür ist (neben der hier beschriebenen Austattung) ein eigener bzw. gemieteter Internet Server. Die Vorgehensweise lässt sich jedoch an verschiedene Anwendungsbereiche (also z.B. auch öffentlicher Livestream) anpassen.

![unser Gemeinde](bilder/saal.jpg)

> In der aktuellen Situation (Corona-Kriese 2020) erfolgt die Übertragung der Gottesdienste ausschliesslich online und wir bekommen sehr positives Feedback, dass so eine Verbundenheit miteinander bestehen bleibt.
>

Diese Dokumentation darf gemäss der [CC BY-NC-SA 3.0](https://creativecommons.org/licenses/by-nc-sa/3.0/de/) Lizenz verwendet und bearbeitet werden.

## Ausstattung

### Hardware

- [Kamera](#kamera)
- [HDMI Audio Inserter](#hdmi-audio-inserter)
- [Encoder](#encoder)
- [Audio-Mischpult](#audio-mischpult)
- [PC](#pc)
- [Server](#server)

### Software

- OBS-Studio
- MistServer

-----

### Kamera

Als Kamera nutzen wir eine Canon LEGRIA HF R77. Das ist ein "normaler" Camcorder aus dem Heimvideo-Bereich. Wichtig ist hier ein HDMI-Ausgang, der das Live-Bild ausgibt und die Möglichkeit, den Camcorder auch ohne Aufnahme im Dauerbetrieb laufen zu lassen. Einige Camcorder schalten nach einer gewissen Zeit im Leerlauf ab. In diesem Fall könnte man aber auch einfach die Aufnahme aktivieren, sofern das Live-Bild trotzdem über den HDMI-Ausgang gesendet wird.

![Kamera](bilder/kamera.jpg)


### HDMI-Audio-Inserter

Der HDMI-Ausgang der Kamera ist zunächst mit einem sogenannten "HDMI-Audio-Inserter" verbunden. Wir verwenden das Modell HM-CV032K von SPEAKA. Wie der Name schon sagt, ist der Zweck dieses kleinen Kastens, ein externes Audiosignal in den HDMI-Datenstrom der Kamera einzufügen bzw. den Originalton der Kamera zu ersetzen. Natürlich könnte man auch den Ton der Kamera verwenden, wobei die Qualität dann aber deutlich geringer sein dürfte, als bei einem direkt vom Audiomischpult abgegriffenen Signal.

![HDMI Audio Inserter](bilder/hdmi_audio_insert.jpg)

Wenn man den Ton der Kamera nicht verwenden möchte, ist auf jedan Fall das Einfügen des Audiosignals **vor** dem Encoder notwendig, um die Syncronität von Bild und Ton beizubehalten. Softwareseitig (im OBS-Studio) könnte man auch noch Tonspuren einfügen, die würden dann aber im fertigen Stream zeitversetzt vor dem Bild laufen, weil der Encoder den HDMI-Datenstrom leicht verzögert ausgibt.

> Neuere Encoder haben die Audio-Insert-Funktion bereits integriert und man kann das Audiosignal direkt in den Encoder einspeisen. Das von uns verwendete Modell ist eine Vorgängerversion der aktuellen Serie und besitzt keinen Audio-Eingang.


### Encoder

Obwohl man mit Hilfe eines HDMI-Grabbers (HDMI-Capture) den HDMI-Datenstrom direkt in den Computer übertragen, und dort im OBS-Studio den Ton dazu mischen könnte, haben wir uns aus verschiedenen Gründen für eine externe Lösung in Form eines IPTV-Encoders entschieden:

* Ein externes Gerät entlastet den Computer. In unserem Fall läuft darauf neben dem OBS-Studio auch noch [OpenLP](https://openlp.org) damit das Beamer-Bild in den Video-Stream integriert werden kann
* Der von uns verwendete Encoder [IRENIS ADE-264](https://www.blankom.de/ip-encoder-en/iptv-streamer-encoder-hdmi-cvbs-input-irenis-ade-264/) kann 2 Streams mit unterschiedlichen Auflösungen und Kompressionsraten erzeugen. Wir nutzen das, um einen Stream mit höherer Auflösung an einen Monitor in unserem Eltern-Kind-Raum zu senden. Der zweite Stream wird über das OBS-Studio an unseren Internet-Server geschickt.

![Encoder](bilder/encoder.jpg)


### Audio-Mischpult

Die Einstellungen des Audio-Mixers, der für die Beschallung unserer Gottesdienste verwendet wird, entsprechen in den meisten Fällen nicht denen, die für eine Aufnahme bzw. Übertragung notwendig sind. Da reicht von unterschiedlichen Lautstärkeverhältnissen zwischen Musik und Sprache bis zu den Klang- und Dynamikeinstellungen der einzelnen Kanäle. Neuere und größere Digital-Mischpulte, wie das von und verwendete [Soundcraft Si Impact](https://www.soundcraft.com/products/si-impact) bieten die Möglichkeit, einen Sub-Mix zu erstellen und an seperate Ausgänge zu legen. Weil das ziemlich komplexe Einstellungen sind und unerfahrene Techniker schnell an ihre Grenzen bringt, verwenden wir ein zusätzliches kleines Digital-Mischpult für den Video-Ton. 

![Mixer](bilder/mixer.jpg)

Das [Soundcraft Ui12](https://www.soundcraft.com/en-US/products/ui12) ist sehr kompakt und wird über eine Netzwerkverbindung mit dem Internet-Browser bedient. Das hat natürlich auch den Vorteil, dass man die Einstellungen z.B. vom Eltern-Kind Übertragungsraum aus vornehmen kann und so eine direkte Kontrolle des Ergebnisses hat. In der aktuellen Einstellung wird das Summen-Signal vom "großen Bruder" und zusätzlich noch einmal der Mikrofonkanal vom Rednerpult eingespeist. Die Lautstärke des Mikrofonkanals wird mit Hilfe der Dynamik-Effekte (Kompressor/Limiter/Gate) angepasst. Als weitere "Ausbaustufe" wären z.B. zusätzliche Raum-Mikrofone denkbar, die das Live-Empfinden der Zuschauer verbessern, da die ganze Raumakustik (Gemeindegesang,...) mit eingefangen wird.


### PC

Als PC verwenden wir einen handelsüblichen Büro-Computer mit [Ubuntu](https://ubuntu.com/) als Betriebssysthem. Wichtig ist hier, dass der Computer über ausreichend Leistung verfügt, um Lieder und Multimedia-Inhalte mit [OpenLP](https://openlp.org) am Beamer anzuzeigen und gleichzeitig den Video-Stream mit [OBS-Studio](https://obsproject.com/) an den Server zu senden. Das Video-Signal wird hierbei teilweise mit dem Beamer-Bild überlagert und muss demzufolge noch einmal neu encodiert werden (ein Intel i3 mit 8GB Ram ist hier bereits ausreichend).


### Server
[zum Anfang](#)

Für die bereitstellung des Video-Live-Streams über das Internet verwenden wir einen gemieteten root-Server. Die detailierte Beschreibung der Einrichtung des Servers würde hier zu weit führen. Wer einen eigenen Server betreibt, sollte auf jeden Fall über ausreichende Kenntnisse in diesem Bereich verfügen. Die erforderliche Leistung des Servers hängt von der Anzahl der gleichzeitigen Zuschauer des Live-Streams ab. Neben der reinen Prozessorleistung bzw. Arbeitsspeichergröße, ist dabei auch die Netzwerk-Last zu beachten. In unserer ersten Installation hatte ein root-Server mit 2 Kernen und 8GB Ram bei 48 Clients etwa 35% CPU-Last. Im Downstream (Server zu Clients) lagen ca. 80 MBit/s an. Vereinzelt haben Zuschauer von stockendem Bild und Ton berichtet, wobei für uns nicht eindeutig klar ist, ob das Problem beim Server oder bei den Clients lag.